VERSION 5.00
Begin VB.UserControl StatusBar 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "SBar"
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   375
   End
End
Attribute VB_Name = "StatusBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright by ALXR: Founder1e2[at]gmail[dot]com

Private Const SB_SETBKCOLOR As Long = &H2001&
Private Const SB_GETBORDERS As Long = 1031
Private Const SB_GETICON As Long = 1044
Private Const SB_GETPARTS As Long = 1030
Private Const SB_GETRECT As Long = 1034
Private Const SB_GETTEXTW As Long = 1037
Private Const SB_GETTEXTLENGTHW As Long = 1036
Private Const SB_SETTEXTW As Long = 1035
Private Const SB_GETTEXTA As Long = 1026
Private Const SB_GETTEXTLENGTHA As Long = 1027
Private Const SB_SETTEXTA As Long = 1025
Private Const SB_SETMINHEIGHT As Long = 1032
Private Const SB_SETICON As Long = 1039
Private Const SB_SETPARTS As Long = 1028
Private Const SB_SETTIPTEXTA = (&H400 + 16)
Private Const SB_SETTIPTEXTW = (&H400 + 17)
Private Const SB_GETTIPTEXTA = (&H400 + 18)
Private Const SB_GETTIPTEXTW = (&H400 + 19)

Private Const SB_SIMPLE As Long = 1033
Private Const SB_SETTEXT As Long = SB_SETTEXTA
Private Const SB_GETTEXT As Long = SB_GETTEXTA
Private Const SB_GETTEXTLENGTH As Long = SB_GETTEXTLENGTHA
Private Const SB_GETTIPTEXT = SB_GETTIPTEXTA
Private Const SB_SETTIPTEXT = SB_SETTIPTEXTA
Private Const CLR_DEFAULT As Long = &HFF000000

Private Type ICC
  dwLength As Long
  dwICC As Long
End Type

'Enum CTL_STATUSBAR_STYLES
'  SBARS_SIZEGRIP = 256
'End Enum

'Enum STATUS_ITEM_BORDER
'  SBT_SIMPLE = 0
'  SBT_NOBORDERS = 256
'  SBT_OWNERDRAW = 4096
'  SBT_POPOUT = 512
'  SBT_RTLREADING = 1024
'  SBT_TOOLTIP = &H800&
'End Enum

Private Declare Function SendMessageA Lib "user32.dll" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function SendMsg Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Sub InitCommonControlsEx Lib "comctl32.dll" (ICC As ICC)
Private Declare Function OleTranslateColor Lib "olepro32.dll" (ByVal cr As Long, ByVal hPal As Long, clr As Long) As Long

Dim hStatus As Long, lCount As Long, v As Variant
Dim crColor As Long

Public Sub Create(hParent As Long, Optional ByVal dwStyle As CTL_STATUSBAR_STYLES, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
  Dim x&, y&, cx&, cy&
  dwStyle = dwStyle Or &H40000000
  If bVisible Then dwStyle = dwStyle Or &H10000000
  hStatus = CreateWindowExA(dwExStyle, "msctls_statusbar32", "", dwStyle, x, y, cx, cy, hParent, 0, App.hInstance, ByVal 0&)
  Call ParentSizeChanged
End Sub

Sub SetBounds(ParamArray vWidth())
  On Error Resume Next
  Dim l As Long, i As Long, cx As Long, lWidth() As Long, lcx As Long
  l = UBound(vWidth)
  If Err.Number = 9 Then Err.Clear: l = -1
  If l = -1 Then Exit Sub
  ReDim lWidth(0 To l)
  cx = 0
  For i = 0 To l
  lcx = CLng(vWidth(i))
  If lcx > 0 Then
      cx = cx + lcx
      lWidth(i) = cx
  ElseIf i < l Then
      ReDim Preserve lWidth(0 To i): l = i
      lWidth(i) = -1
      Exit For
  Else
      lWidth(i) = -1
  End If
  Next
  Call SendMessageA(hStatus, SB_SETPARTS, l + 1, VarPtr(lWidth(0)))
End Sub

Sub ParentSizeChanged()
  Call SendMessageA(hStatus, 5, 0, 0&)
End Sub

Property Get Text(ByVal i As Integer) As String
  Dim l As Long, S As String
  l = (SendMessageA(hStatus, SB_GETTEXTLENGTH, i, 0&) And &HFFFF&)
  S = String(l + 1, 0)
  Call SendMessageA(hStatus, SB_GETTEXT, i, S)
  Text = Left(S, l)
End Property

Property Get Border(ByVal i As Integer) As STATUS_ITEM_BORDER
  Border = (SendMessageA(hStatus, SB_GETTEXTLENGTH, i, 0&) And &HFFFF0000) \ &H10000
End Property

Property Get Icon(ByVal i As Integer) As Long
  Icon = SendMessageA(hStatus, SB_GETICON, i, 0&)
End Property

Property Get Tip(ByVal i As Integer) As String
  Dim S As String, l As Long
  S = String(32767, 0)
  Call SendMessageA(hStatus, SB_GETTIPTEXT, CLng(Len(S) * 65536 + i), S)
  l = InStr(S, vbNullChar)
  Tip = IIf(l > 0, Left(S, l - 1), S)
End Property

Property Get BackColor() As Long
  BackColor = crColor
End Property

Property Let Icon(ByVal i As Integer, ByVal hIcon As Long)
  Call SendMessageA(hStatus, SB_SETICON, i, hIcon)
End Property

Property Let Text(ByVal i As Integer, ByVal lp As String)
  Call SendMessageA(hStatus, SB_SETTEXT, i Or Me.Border(i), lp)
End Property

Property Let Border(ByVal i As Integer, ByVal dw As STATUS_ITEM_BORDER)
  Call SendMessageA(hStatus, SB_SETTEXT, i Or dw, Me.Text(i))
End Property

Property Let Tip(ByVal i As Integer, ByVal lp As String)
  Call SendMessageA(hStatus, SB_SETTIPTEXT, i, lp)
End Property

Property Get Tag() As Variant
  Tag = v
End Property

Property Let Tag(ByVal vt As Variant)
  v = vt
End Property

Property Let BackColor(ByVal dwColor As Long)
  Dim c As Long
  crColor = dwColor
  If dwColor <> -1 Then
      OleTranslateColor dwColor, 0, c
      Call SendMessageA(hStatus, SB_SETBKCOLOR, 0, c)
  Else
      Call SendMessageA(hStatus, SB_SETBKCOLOR, 0, CLR_DEFAULT)
  End If
End Property

Private Sub UserControl_Initialize()
  Dim lpicc As ICC
  UserControl.BackColor = vbWhite
  lpicc.dwLength = Len(lpicc)
  lpicc.dwICC = &H3FFF&
  Call InitCommonControlsEx(lpicc)
  lCount = 0
End Sub

Private Sub UserControl_Resize()
  On Error Resume Next
  UserControl.Width = 24 * 15
  UserControl.Height = Width
End Sub

Private Sub UserControl_Terminate()
  Call DestroyWindow(hStatus)
End Sub
