VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsHotKey"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright by ALXR: Founder1e2[at]gmail[dot]com

Private Declare Function SendMessageA Lib "user32.dll" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function SendMsg Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Sub InitCommonControlsEx Lib "comctl32.dll" (ICC As ICC)

Private Type ICC
    dwLength As Long
    dwICC As Long
End Type

Private Const HKM_GETHOTKEY As Long = 1026
Private Const HKM_SETHOTKEY As Long = 1025
Private Const HKM_SETRULES As Long = 1027
Private Const WM_SETHOTKEY As Long = 50
Private Const WM_GETHOTKEY As Long = 51

Enum INVALID_MODIFIERS
    HOTKEYF_ALT = 4
    HOTKEYF_CONTROL = 2
    HOTKEYF_EXT = 8
    HOTKEYF_SHIFT = 1
End Enum

Enum INVALID_KEYS
    HKCOMB_A = 8
    HKCOMB_C = 4
    HKCOMB_CA = 64
    HKCOMB_NONE = 1
    HKCOMB_S = 2
    HKCOMB_SA = 32
    HKCOMB_SC = 16
    HKCOMB_SCA = 128
End Enum

Dim hHotKey As Long

Private Sub Class_Initialize()
Dim lpicc As ICC
lpicc.dwLength = Len(lpicc)
lpicc.dwICC = &H3FFF&
Call InitCommonControlsEx(lpicc)
End Sub

Private Sub Class_Terminate()
DestroyWindow hHotKey
End Sub

Sub Create(fParent As Object, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, Optional ByVal dwStyle As Long, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
Dim hParent As Long
If TypeOf fParent Is Form Or TypeOf fParent Is PictureBox Then
    x = fParent.ScaleX(x, fParent.ScaleMode, vbPixels): cx = fParent.ScaleX(cx, fParent.ScaleMode, vbPixels)
    y = fParent.ScaleY(y, fParent.ScaleMode, vbPixels): cy = fParent.ScaleY(cy, fParent.ScaleMode, vbPixels)
ElseIf TypeOf fParent Is Frame Then
    x = x / Screen.TwipsPerPixelX: y = y / Screen.TwipsPerPixelY
    cx = cx / Screen.TwipsPerPixelX: cy = cy / Screen.TwipsPerPixelY
Else
    Exit Sub
End If
dwStyle = dwStyle Or &H40000000
If bVisible Then dwStyle = dwStyle Or &H10000000
hParent = fParent.hWnd
hHotKey = CreateWindowExA(dwExStyle, "msctls_hotkey32", "", dwStyle, x, y, cx, cy, hParent, 0, App.hInstance, ByVal 0&)
If hHotKey <> 0 Then SendMessageA hHotKey, 48, SendMessageA(hParent, 49, 0, 0&), 1&
End Sub

Sub CreateOnShape(fParent As Object, fPrototype As Shape, Optional ByVal dwStyle As Long, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
Call Create(fParent, fPrototype.Left, fPrototype.Top, fPrototype.Width, fPrototype.Height, dwStyle, dwExStyle, bVisible)
fPrototype.Visible = (hHotKey = 0)
End Sub

Property Get HotKey() As Long
HotKey = SendMessageA(hHotKey, HKM_GETHOTKEY, 0, 0&)
End Property

Property Let HotKey(ByVal dwHotKey As Long)
Call SendMessageA(hHotKey, HKM_SETHOTKEY, dwHotKey, 0&)
End Property

Property Get WindowHotKey(ByVal hWnd As Long) As Long
WindowHotKey = SendMessageA(hWnd, WM_GETHOTKEY, 0, 0&)
End Property

Property Let WindowHotKey(ByVal hWnd As Long, ByVal dwHotKey As Long)
Call SendMessageA(hWnd, WM_SETHOTKEY, dwHotKey, 0&)
End Property

Sub SetInvalidHotKeys(ByVal dwInvalidKeys As INVALID_KEYS, ByVal dwInvalidModifiers As INVALID_MODIFIERS)
SendMessageA hHotKey, HKM_SETRULES, dwInvalidKeys, dwInvalidModifiers
End Sub
