VERSION 5.00
Begin VB.UserControl Progress 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
End
Attribute VB_Name = "Progress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Created by ALXR: mailto: Founder1e2[at]gmail[dot]com

'Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function SendMsg Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageA Lib "user32" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetWindowLongA Lib "user32" (ByVal hWnd As Long, ByVal nParam As Long) As Long
Private Declare Function SetWindowLongA Lib "user32" (ByVal hWnd As Long, ByVal nParam As Long, ByVal dwNewValue As Long) As Long
Private Declare Function OleTranslateColor Lib "olepro32.dll" (ByVal cr As Long, ByVal hPal As Long, clr As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Enum PROGRESS_STYLES
    PBS_SMOOTH = 1
    PBS_VERTICAL = 4
End Enum

Enum PROGRESS_BORDER
    PRB_NONE = 0
    PRB_STATICEDGE = 1
    PRB_CLIENTEDGE = 2
End Enum

Private Const PBM_DELTAPOS As Long = 1027
Private Const PBM_GETPOS As Long = 1032
Private Const PBM_SETPOS As Long = 1026
Private Const PBM_GETRANGE As Long = 1031
Private Const PBM_SETRANGE As Long = 1025
Private Const PBM_SETSTEP As Long = 1028
Private Const PBM_STEPIT As Long = 1029
Private Const PBM_SETBARCOLOR = 1033
Private Const PBM_SETBKCOLOR = &H2001

Dim hProgress As Long, clr As OLE_COLOR, fore_clr As OLE_COLOR, iProgressStep As Long

Private Sub Create(ByVal dwHwnd As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, Optional ByVal bVisible As Boolean = True, Optional ByVal dwStyle As PROGRESS_STYLES)
  If bVisible Then dwStyle = dwStyle Or &H10000000
  hProgress = CreateWindowExA(0, "msctls_progress32", vbNullString, &H40000000 Or dwStyle, x, y, cx, cy, dwHwnd, 0, App.hInstance, ByVal 0&)
  If hProgress <> 0 Then Me.BackColor = clr
  Me.ForeColor = fore_clr
  Me.Delta = iProgressStep
End Sub

Property Get Value() As Long
  Value = SendMessageA(hProgress, PBM_SETPOS, 0, 0&)
  Call SendMessageA(hProgress, PBM_SETPOS, Value, 0&)
End Property

Property Get hWnd() As Long
  hWnd = hProgress
End Property

Property Get Min() As Long
  Min = SendMessageA(hProgress, PBM_GETRANGE, 1, 0&)
End Property

Property Get Max() As Long
  Max = SendMessageA(hProgress, PBM_GETRANGE, 0, 0&)
End Property

Property Get BackColor() As OLE_COLOR
  BackColor = clr
End Property

Property Get ForeColor() As OLE_COLOR
  ForeColor = fore_clr
End Property

Property Get Delta() As Long
  Delta = iProgressStep
End Property

Property Let Value(ByVal v As Long)
  Call SendMessageA(hProgress, PBM_SETPOS, v, 0&)
End Property

Property Let Min(ByVal v As Long)
  Call SendMessageA(hProgress, PBM_SETRANGE, 0, Me.Max * 65536 + v)
End Property

Property Let Max(ByVal v As Long)
  Call SendMessageA(hProgress, PBM_SETRANGE, 0, v * 65536 + Me.Min)
End Property

Property Let BackColor(ByVal new_clr As OLE_COLOR)
  Dim c As Long
  clr = new_clr
  Call OleTranslateColor(new_clr, 0, c)
  Call SendMessageA(hProgress, PBM_SETBKCOLOR, 0, c)
End Property

Property Let ForeColor(ByVal new_clr As OLE_COLOR)
  Dim c As Long
  fore_clr = new_clr
  Call OleTranslateColor(new_clr, 0, c)
  Call SendMessageA(hProgress, PBM_SETBARCOLOR, 0, c)
End Property

Property Let Delta(ByVal iStep As Long)
  Call SendMessageA(hProgress, PBM_SETSTEP, iStep, 0&)
End Property

Private Sub Inc(Optional ByVal iStep As Long = 0)
  If iStep = 0 Then
    Call SendMessageA(hProgress, PBM_STEPIT, 0, 0&)
  Else
    Call SendMessageA(hProgress, PBM_DELTAPOS, iStep, 0&)
  End If
End Sub

'40100C0h
Property Get Border() As PROGRESS_BORDER
  Dim w As Long
  w = GetWindowLongA(hProgress, -20)
  If CBool(w And &H200) Then
    Border = PRB_CLIENTEDGE
  ElseIf CBool(w And &H20000) Then
    Border = PRB_STATICEDGE
  Else
    Border = PRB_NONE
  End If
End Property

Property Let Border(ByVal v As PROGRESS_BORDER)
  Dim w As Long
  w = (GetWindowLongA(hProgress, -20) And Not &H20200)
  Select Case v
  Case PRB_STATICEDGE: w = w Or &H20000
  Case PRB_CLIENTEDGE: w = w Or &H200
  End Select
  Call SetWindowLongA(hProgress, -20, w)
  Call SetWindowPos(hProgress, 0, 0, 0, 0, 0, 32 Or 3 Or 16 Or 512)
End Property

Private Sub UserControl_Initialize()
  'Call InitCommonControls
  fore_clr = vbHighlight
  clr = vbButtonFace
  iProgressStep = 1
  UserControl.ScaleMode = vbPixels
  Call Create(UserControl.hWnd, 0, 0, ScaleWidth, ScaleHeight, True, PBS_SMOOTH)
End Sub

Private Sub UserControl_Resize()
  Call Move(0, 0, ScaleWidth, ScaleHeight)
End Sub

Private Sub Move(tsLeft As Long, tsTop As Long, tsWidth As Long, tsHeight As Long)
  If hProgress <> 0 Then Call MoveWindow(hProgress, tsLeft, tsTop, tsWidth, tsHeight, 1)
End Sub

