VERSION 5.00
Begin VB.UserControl SysMonthCal 
   ClientHeight    =   2250
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2280
   ScaleHeight     =   2250
   ScaleWidth      =   2280
End
Attribute VB_Name = "SysMonthCal"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const GDT_ERROR = -1
Private Const GDT_VALID = 0
Private Const GDT_NONE = 1
Private Const GDTR_MIN = &H1
Private Const GDTR_MAX = &H2

Private Const ICC_LISTVIEW_CLASSES = &H1       ' listview, header
Private Const ICC_TREEVIEW_CLASSES = &H2       ' treeview, tooltips
Private Const ICC_BAR_CLASSES = &H4            ' toolbar, statusbar, trackbar, tooltips
Private Const ICC_TAB_CLASSES = &H8            ' tab, tooltips
Private Const ICC_UPDOWN_CLASS = &H10          ' updown
Private Const ICC_PROGRESS_CLASS = &H20        ' progress
Private Const ICC_HOTKEY_CLASS = &H40          ' hotkey
Private Const ICC_ANIMATE_CLASS = &H80         ' animate
Private Const ICC_WIN95_CLASSES = &HFF
Private Const ICC_DATE_CLASSES = &H100         ' month picker, date picker, time picker, updown
Private Const ICC_USEREX_CLASSES = &H200       ' comboex
Private Const ICC_COOL_CLASSES = &H400         ' rebar (coolbar) control
Private Const ICC_INTERNET_CLASSES = &H800
Private Const ICC_PAGESCROLLER_CLASS = &H1000  ' page scroller
Private Const ICC_NATIVEFNTCTL_CLASS = &H2000  ' native font control

Private Const WS_VISIBLE = &H10000000
Private Const WS_CHILD = &H40000000
Private Const WS_TABSTOP As Long = &H10000
Private Const vNull                 As Long = 0&

Private Const DTM_FIRST = &H1000
Private Const DTM_GETSYSTEMTIME = DTM_FIRST + 1
Private Const DTM_SETRANGE = DTM_FIRST + 4
Private Const DTM_SETSYSTEMTIME = DTM_FIRST + 2
Private Const DTM_GETMINREQRECT = DTM_FIRST + 9
Private Const DTM_SETTODAY = DTM_FIRST + 12
Private Const DTM_GETTODAY = DTM_FIRST + 13
Private Const DTM_SETFIRSTDAYOFWEEK = DTM_FIRST + 15
Private Const DTM_GETFIRSTDAYOFWEEK = DTM_FIRST + 16

Private Type InitCommonControlsExType
  dwSize As Long
  dwICC As Long
End Type

Private Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Private Type POINTAPI
  x As Long
  y As Long
End Type

Private Type RECT
    Left            As Long
    Top             As Long
    Right           As Long
    Bottom          As Long
End Type

Private Declare Sub InitCommonControls Lib "comctl32" ()
Private Declare Function InitCommonControlsEx Lib "comctl32" (init As InitCommonControlsExType) As Boolean
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SetFocus Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Const WM_MOUSEACTIVATE = &H21
Private Const WM_SETFOCUS = &H7
Private Const WM_NCLBUTTONUP = &HA2

Dim hWnd As Long

Private Sub CreateControl()
    Const IE3_INSTALLED = True
    Dim initcc As InitCommonControlsExType
    
    If IE3_INSTALLED = True Then
     initcc.dwSize = Len(initcc)
     initcc.dwICC = &H100
     InitCommonControlsEx initcc
    Else
     Call InitCommonControls
    End If
    
    hWnd = CreateWindowEx(0&, "SysMonthCal32", "Forum.Sources.ru", WS_CHILD Or WS_TABSTOP Or WS_VISIBLE, _
                          0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight, UserControl.hWnd, ByVal 0&, ByVal 0&, ByVal 0&)
End Sub

Property Get Value() As Date
  Dim st As SYSTEMTIME
  Call SendMessage(hWnd, DTM_GETSYSTEMTIME, 0, st)
  With st
    Value = CDate(CStr(.wDay) & "/" & CStr(.wMonth) & "/" & CStr(.wYear))
  End With
End Property

Property Let Value(ByVal dtDate As Date)
  Dim st As SYSTEMTIME
  With st
    .wDay = Day(dtDate)
    .wMonth = Month(dtDate)
    .wYear = Year(dtDate)
  End With
  Call SendMessage(hWnd, DTM_SETSYSTEMTIME, GDT_VALID, st)
End Property

Public Property Get FirstDayWeek() As Integer                                         '    
Dim dWord As Long
    dWord = SendMessage(hWnd, DTM_GETFIRSTDAYOFWEEK, 0&, ByVal 0&)
    FirstDayWeek = IIf(dWord And &H8000&, dWord Or &HFFFF0000, dWord And &HFFFF&)
End Property

Public Property Let FirstDayWeek(ByVal newVal As Integer)
    Call SendMessage(hWnd, DTM_SETFIRSTDAYOFWEEK, 0&, ByVal newVal)
End Property

Public Property Get Today() As Date
  Dim st As SYSTEMTIME
  Call SendMessage(hWnd, DTM_GETTODAY, 0, st)
  With st
    Today = CDate(CStr(.wDay) & "/" & CStr(.wMonth) & "/" & CStr(.wYear))
  End With
End Property

Public Property Let Today(ByVal dtDate As Date)
  Dim st As SYSTEMTIME
  With st
    .wDay = Day(dtDate)
    .wMonth = Month(dtDate)
    .wYear = Year(dtDate)
  End With

  Call SendMessage(hWnd, DTM_SETTODAY, vNull, st)
  Value = dtDate
End Property

Private Sub UserControl_EnterFocus()
  Call SetFocus(hWnd)
End Sub

Private Sub UserControl_Initialize()
 UserControl.ScaleMode = vbPixels
 Call CreateControl
End Sub

Private Sub UserControl_Resize()
  Dim tmpRECT As RECT
  Call SendMessage(hWnd, DTM_GETMINREQRECT, vNull, tmpRECT)
  With UserControl
   .Height = tmpRECT.Bottom * 15
   .Width = tmpRECT.Right * 15
  End With
  Call MoveWindow(hWnd, 0, 0, tmpRECT.Right, tmpRECT.Bottom, 1)
End Sub

Private Sub UserControl_Terminate()
  Call DestroyWindow(hWnd)
End Sub
