VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsSysAnimate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright by ALXR: Founder1e2[at]gmail[dot]com

#Const WIN95 = 0
#Const WIN_UNICODE = 1 - WIN95

Enum CTL_ANIMATE_STYLES
    ACS_AUTOPLAY = 4
    ACS_CENTER = 1
    ACS_TRANSPARENT = 2
    ACS_TIMER = 8
End Enum

Private Const ACM_OPENW = 1127
Private Const ACM_OPENA = 1124
Private Const ACM_PLAY = 1125
Private Const ACM_STOP = 1126

Private Declare Function SendMessageA Lib "user32.dll" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Any) As Long
Private Declare Function SendMsg Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Sub InitCommonControlsEx Lib "comctl32.dll" (ICC As ICC)

Private Type ICC
    dwLength As Long
    dwICC As Long
End Type


#If WIN_UNICODE Then
    Private Const ACM_OPEN = ACM_OPENW
#Else
    Private Const ACM_OPEN = ACM_OPENA
#End If

Dim hAnimate As Long
Dim iStart As Integer, iEnd As Integer, iRepeatCount As Integer

Private Sub Class_Initialize()
Dim lpicc As ICC
lpicc.dwLength = Len(lpicc)
lpicc.dwICC = &H3FFF&
Call InitCommonControlsEx(lpicc)
iEnd = -1
End Sub

Private Sub Class_Terminate()
DestroyWindow hAnimate
End Sub

#If WIN_UNICODE Then
    Private Function GetString(ByVal lp As String) As String
    GetString = StrConv(lp, vbUnicode)
    End Function
#Else
    Private Function GetString(ByVal lp As String) As String
    GetString = lp
    End Function
#End If

Sub Create(fParent As Object, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, Optional ByVal dwStyle As CTL_ANIMATE_STYLES, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
Dim hParent As Long
If TypeOf fParent Is Form Or TypeOf fParent Is PictureBox Then
    x = fParent.ScaleX(x, fParent.ScaleMode, vbPixels): cx = fParent.ScaleX(cx, fParent.ScaleMode, vbPixels)
    y = fParent.ScaleY(y, fParent.ScaleMode, vbPixels): cy = fParent.ScaleY(cy, fParent.ScaleMode, vbPixels)
ElseIf TypeOf fParent Is Frame Then
    x = x / Screen.TwipsPerPixelX: y = y / Screen.TwipsPerPixelY
    cx = cx / Screen.TwipsPerPixelX: cy = cy / Screen.TwipsPerPixelY
Else
    Exit Sub
End If
dwStyle = dwStyle Or &H40000000
If bVisible Then dwStyle = dwStyle Or &H10000000
hParent = fParent.hWnd
hAnimate = CreateWindowExA(dwExStyle, "SysAnimate32", "", dwStyle, x, y, cx, cy, hParent, 0, App.hInstance, ByVal 0&)
End Sub

Sub CreateOnShape(fParent As Object, fPrototype As Shape, Optional ByVal dwStyle As CTL_ANIMATE_STYLES, Optional ByVal dwExStyle As Long, Optional ByVal bVisible As Boolean = True)
Call Create(fParent, fPrototype.Left, fPrototype.Top, fPrototype.Width, fPrototype.Height, dwStyle, dwExStyle, bVisible)
fPrototype.Visible = (hAnimate = 0)
End Sub

Sub LoadFromFile(ByVal lpFile As String)
SendMessageA hAnimate, ACM_OPEN, 0, GetString(lpFile)
End Sub

Sub LoadFromResInt(ByVal iResId As Integer)
SendMessageA hAnimate, ACM_OPEN, 0, CLng(iResId)
End Sub

Sub CloseAnimation()
SendMessageA hAnimate, ACM_OPEN, 0, 0&
End Sub

Sub StopAnimation()
SendMessageA hAnimate, ACM_STOP, 0, 0&
End Sub

Sub PlayAnimation()
SendMessageA hAnimate, ACM_PLAY, iRepeatCount, iEnd * 65536 + iStart
End Sub

Property Get Start() As Integer
Start = iStart
End Property

Property Get Finish() As Integer
Finish = iEnd
End Property

Property Get Repeat() As Integer
Repeat = iRepeatCount
End Property

Property Let Start(ByVal i As Integer)
iStart = i
End Property

Property Let Finish(ByVal i As Integer)
iEnd = i
End Property

Property Let Repeat(ByVal i As Integer)
iRepeatCount = i
End Property

